import 'package:flutter/src/widgets/framework.dart';
import 'package:hub/backend/api_requests/api_calls.dart';
import 'package:hub/backend/api_requests/api_manager.dart';
import 'package:hub/flutter_flow/flutter_flow_model.dart';
import 'package:hub/flutter_flow/nav/nav.dart';
import 'package:hub/pages/visit_history_page/visit_history_page_widget.dart';

class VisitHistoryModel extends FlutterFlowModel<VisitHistoryWidget> {
  @override
  void dispose() {
    // TODO: implement dispose
  }

  @override
  void initState(BuildContext context) {
    // TODO: implement initState
  }

  Future changeStatusAction(
    BuildContext context,
    int idDestino,
    int idVisita,
    String accessKey,
    String email,
  ) async {
    // Navigator.pop(context, true);
    context.pop(true);

    bool? blockVisitRequest;
    blockVisitRequest = await visitCancelAction(
      context,
      accessKey: accessKey,
      idDestino: idDestino,
      idVisita: idVisita,
      email: email,
    );
    if (!context.mounted) return;
    if (blockVisitRequest == true) {
      return true;
    } else {
      return false;
    }
  }

  Future<bool> visitCancelAction(BuildContext context,
      {required int? idDestino,
      required int? idVisita,
      required String? accessKey,
      required String? email}) async {
    final ApiCallResponse? response;
    final CancelaVisita callback = PhpGroup.cancelaVisita;

    response = await callback.call(
      idDestino: idDestino,
      idVisita: idVisita,
      AccessKey: accessKey,
      UsuEmail: email,
      DevDesc: '',
    );

    if (response.statusCode == 200) {
      return !response.jsonBody['error'];
    } else {
      return false;
    }
  }
}
